Upstream information

CVE-2022-24761 at MITRE

Description

Waitress is a Web Server Gateway Interface server for Python 2 and 3. When using Waitress versions 2.1.0 and prior behind a proxy that does not properly validate the incoming HTTP request matches the RFC7230 standard, Waitress and the frontend proxy may disagree on where one request starts and where it ends. This would allow requests to be smuggled via the front-end proxy to waitress and later behavior. There are two classes of vulnerability that may lead to request smuggling that are addressed by this advisory: The use of Python's `int()` to parse strings into integers, leading to `+10` to be parsed as `10`, or `0x01` to be parsed as `1`, where as the standard specifies that the string should contain only digits or hex digits; and Waitress does not support chunk extensions, however it was discarding them without validating that they did not contain illegal characters. This vulnerability has been patched in Waitress 2.1.1. A workaround is available. When deploying a proxy in front of waitress, turning on any and all functionality to make sure that the request matches the RFC7230 standard. Certain proxy servers may not have this functionality though and users are encouraged to upgrade to the latest version of waitress instead.

SUSE information

Overall state of this security issue: Pending

This issue is currently rated as having important severity.

CVSS v2 Scores
  National Vulnerability Database
Base Score 5
Vector AV:N/AC:L/Au:N/C:N/I:P/A:N
Access Vector Network
Access Complexity Low
Authentication None
Confidentiality Impact None
Integrity Impact Partial
Availability Impact None
CVSS v3 Scores
  National Vulnerability Database SUSE
Base Score 7.5 7.5
Vector CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N
Access Vector Network Network
Access Complexity Low Low
Privileges Required None None
User Interaction None None
Scope Unchanged Unchanged
Confidentiality Impact None None
Integrity Impact High High
Availability Impact None None
CVSSv3 Version 3.1 3.1

Note from the SUSE Security Team

On SUSE OpenStack Cloud we have chosen a workaround instead of fixing python-waitress. The incoming packets will always be RFC7230 thanks to the fronting proxy. Therefore the request smuggling is not exploitable.

SUSE Bugzilla entry: 1197255 [NEW]

No SUSE Security Announcements cross referenced.

List of released packages

Product(s) Fixed package version(s) References
openSUSE Tumbleweed
  • python310-waitress >= 2.1.1-1.1
  • python38-waitress >= 2.1.1-1.1
  • python39-waitress >= 2.1.1-1.1
Patchnames:
openSUSE Tumbleweed GA python310-waitress-2.1.1-1.1


Status of this issue by product and package

Please note that this evaluation state might be work in progress, incomplete or outdated. Also information for service packs in the LTSS phase is only included for issues meeting the LTSS criteria. If in doubt, feel free to contact us for clarification.

Product(s) Source package State
HPE Helion OpenStack 8 python-waitress Ignore
SUSE CaaS Platform 4.0 python-waitress Affected
SUSE Enterprise Storage 6 python-waitress Affected
SUSE Enterprise Storage 7 python-waitress Affected
SUSE Linux Enterprise Desktop 15 SP3 python-waitress Affected
SUSE Linux Enterprise Desktop 15 SP4 python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 LTSS python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP1 ESPOS python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP1 LTSS python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP2 ESPOS python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP2 LTSS python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP3 python-waitress Affected
SUSE Linux Enterprise High Performance Computing 15 SP4 python-waitress Affected
SUSE Linux Enterprise Module for Basesystem 15 SP3 python-waitress Affected
SUSE Linux Enterprise Module for Basesystem 15 SP4 python-waitress Affected
SUSE Linux Enterprise Real Time 15 SP2 python-waitress Affected
SUSE Linux Enterprise Server 15 ESPOS python-waitress Affected
SUSE Linux Enterprise Server 15 LTSS python-waitress Affected
SUSE Linux Enterprise Server 15 SP1 LTSS python-waitress Affected
SUSE Linux Enterprise Server 15 SP2 LTSS python-waitress Affected
SUSE Linux Enterprise Server 15 SP3 python-waitress Affected
SUSE Linux Enterprise Server 15 SP4 python-waitress Affected
SUSE Linux Enterprise Server Business Critical Linux 15 SP1 python-waitress Affected
SUSE Linux Enterprise Server Business Critical Linux 15 SP2 python-waitress Affected
SUSE Linux Enterprise Server for SAP Applications 15 python-waitress Affected
SUSE Linux Enterprise Server for SAP Applications 15 SP1 python-waitress Affected
SUSE Linux Enterprise Server for SAP Applications 15 SP2 python-waitress Affected
SUSE Linux Enterprise Server for SAP Applications 15 SP3 python-waitress Affected
SUSE Linux Enterprise Server for SAP Applications 15 SP4 python-waitress Affected
SUSE Linux Enterprise Storage 7.1 python-waitress Affected
SUSE Manager Proxy 4.1 python-waitress Affected
SUSE Manager Proxy 4.2 python-waitress Affected
SUSE Manager Proxy 4.3 python-waitress Affected
SUSE Manager Retail Branch Server 4.1 python-waitress Affected
SUSE Manager Retail Branch Server 4.2 python-waitress Affected
SUSE Manager Retail Branch Server 4.3 python-waitress Affected
SUSE Manager Server 4.1 python-waitress Affected
SUSE Manager Server 4.2 python-waitress Affected
SUSE Manager Server 4.3 python-waitress Affected
SUSE OpenStack Cloud 8 python-waitress Ignore
SUSE OpenStack Cloud 9 python-waitress Ignore
SUSE OpenStack Cloud Crowbar 8 python-waitress Ignore
SUSE OpenStack Cloud Crowbar 9 python-waitress Ignore